# Debugging with CLion
## Objectives
We are going to quickly go over how to debug with CLion. Our goal is to provide basic concepts on how to use the debugger. This will help you apply concepts and fingure out how to debug a variety of errors as you go.

On Linux, the CLion debugger should take use of GDB for debugging.

Topics include:
* Running the Program
* Breakpoints
* Debugging Mode
* Stepping through the program
* Adding to Watch
* Evaluating Expressions
* Changing Values

---

## Sample Program:

Our sample program is just a bunch of random things thrown together. The program does contain a few bugs that we are going to work out along the way. 

`main.c`

```c
#include <stdio.h>
#include <string.h>
#include <math.h>

int square(int a);


int main() {
    printf("Hello, World!\n");

    int a = 10;
    char x[] = {"This is a string"};
    int sqNum = 0;

    for (int i = 0; i < a; i++) {
        printf("%d\n", i);
    }

    for (int i = 0; i <= strlen(x); i++) {
        printf("%c", x[i]);
    }
    printf("\n");

    printf("===========\n");
    printf("Enter a number that you'd like to find the sqrt of:");
    scanf("%d", sqNum);
    printf("The square root of %d is %d\n", sqNum, square(sqNum));

    return 0;
}


int square(int a) {
    return sqrt(a);
}

```

`CMakeLists.txt`

This is included because the math library needed to be included. This is how we accomplish it:

```c
cmake_minimum_required(VERSION 3.13)
project(debug_demo C)

set(CMAKE_C_STANDARD 99)

add_executable(debug_demo main.c)

target_link_libraries(debug_demo m)

```

---
### Running the program

This is our output:

```
Hello, World!
0
1
2
3
4
5
6
7
8
9
This is a string[] 
===========
Enter a number that you'd like to find the sqrt of:10

Process finished with exit code 139 (interrupted by signal 11: SIGSEGV)
```
* So it doesn't appear we count all the way to 10
* There is some garbage character printing after string
* We get a segfault after inputing our number

---
## Breakpoints

Let's tackle the first issue. We know that it takes place during our for loop. 
Place a break point on `line 15` and monitor the values. To do that, click to the right of line 15. (A red circle will appear) 

![](../assets/clion_breakpoint.png)

---
## Running in Debugging Mode

Next, we are going to engage debugging mode. To do this, click the bug symbol on the run toolbar. 

![](../assets/run_bar.png)

A new window will appear. This is called the debug window:

![](../assets/debug_window.png)

The program was built and ran to line 15 where it stopped.

**Note** If we look at the debug window, we see that it has captured the variables and their values that have been declared and italicized. Click on the arrow next to the string to see all of it's values per index. 

---
## Debug Window

![](../assets/clion_string.png)

Click on the arrow next to the string to see all of it's values per index.
* As you can see, clicking on the arow displays everything, including the nul-terminator.
* This list will continue to get updated as we step through the program.

---
### Stepping Through the Program

Use the buttons located in the top left of the debugging window for stepping through your program.

![](../assets/clion_stepping.png)

* The blue arrow that goes up, then down; is our `step over` button.
    * Stepping over is to step over a loop, condition or function call. 
* The blue arrow that goes down; is our `step into` button
    * Stepping into will step into a loop, condition or function call. 
* The red arrow that goes down; is a `force step into` button
    * Force step is used to step into a system function or something similar. **Note:** if you don't have the source code. it'll display disassembly. 
* The blue arrow going up; is a `step out of` button
    * Step out of will exit something you stepped into. So if you got tired of looping after stepping into... you can step out. 
* The blue arrow pointing to the cursor; will run the program to where your cursor is currently clicked
* The calculator button will Evaluate Expression
  
We will continue to step through our code until we notice something inconsistant with our expected values. This will be viewed in our debugging window as well as our code window.

Below is a screenshot of us having stepped in 6 times; thus i is 5. 

![](../assets/clion_step5.png)

Notice how it displays the itteration for us. 

This makes it slightly easier to know how many times you stepped in without having to look at the debug window. 
**Note:** Based off of our output, we can use common sense and determine we need to step to the end. 

As we have noticed while stepping through our code; the image below shows the last thing we saw prior to exiting the loop. 

![](../assets/clion_step9.png)

We want our program to output 1 through 10, so we need one more iteration.  To do this we need to change i < a to i <= a

After you have made the change, try running the program normally.  
The output should now be 1-10. 

Step through the next issue and see if you can determine the problem. Now fix it! 
**Note:** The problem is fairly easy, but step through it anyway and watch what happens to the values.

Repeat with scanf. 
What happens to the values? Are we core dumping before anything happens? If so, what do we do?

---
## Adding to Watch

IDEs come with great features that allow you to monitor a value or expression by adding it to the watch. To do so, just right click a variable and click `Add to Watches`. 
Once you have added a variable to a watch, you can see it below in your debugging window. 
**Note:** If you don't see it in the window, look for the glasses icon on the debugging window and click on that.

![](../assets/var_watch.png)

Adding items to your watches does more than what the variables window does. Watches will always be displayed. No matter the file, function or state of your variable or expression (more to come). You can see it's status at all times... which can be helpful if you believe something else is effecting it at some point in the program. 

---
## Evaluating Expressions

One of CLion's most powerful tool is evaluating expressions ahead of time; or using custom values. 
(Right click on an expression (a function for example) and click Evaluate) 

![](../assets/clion_eval.png)

In the example; `square()` was evaluated and it's default parameter was replaced with 20. After clicking `Evaluate` at the bottom of the window the output was shown under the `Result` section of the window.

---
## Adding Expression to Watch

To add the Expression Evaluation to the watch list, right click it. (Same as you would on a variable) Then click `Add to Watches`.  You should see your expression and what it would evaluate to in the watches window. 

![](../assets/eval_watch.png)

The value is still 0, due to where the expression was added to watch. If the code had been stepped beyond the scanf, and had an input value; the evaluation would change.

---
## Changing Values

If you change a value in a certain part of the program, it will change the value in the watch window as well.
For example: SqNum was set to 0 in our code.  If we change the 0 to 10 it will change in the other window.  

**Note:** To do this, without changing your code, right click SqNum in the variables debugging window and click `Set Value`.

![](../assets/set_val.png)

Notice, sqNum was set to 10. The watch evaluation also updated. 
All of this happened before we even set sqNum. This can be very useful in some scenarios. 

---
# Summary

Topics Covered included:
* Running the Program
* Breakpoints
* Debugging Mode
* Stepping through the program
* Adding to Watch
* Evaluating Expressions
* Changing Values

On your own time experiment with other useful tools and functionality of the CLion debugger.  This will help you become more familiar with its range of capabilities.
